unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, FileUtil, StdCtrls, Shellapi, registry, ExtCtrls, RXSpin, ToolEdit;

type  TkbRestartOption   = (kbsdLogoff, kbsdShutdown, kbsdReboot, kbsdRestartWindows, kbsdRebootSystem, kbsdExitAndExecApp);

const {Additional flags for RestartDialog}
  EW_RESTARTWINDOWS = $42;
  EW_REBOOTSYSTEM   = $43;
  EW_EXITANDEXECAPP = $44;

function  RestartDialog(Owner: HWND; Reason: Pointer; Flags: UINT): DWORD; stdcall;
function RestartOptionEnumToConst(RestartOption: TkbRestartOption): UINT;

type
  TForm1 = class(TForm)
    OkButton: TButton;
    CancelButton: TButton;
    Label2: TLabel;
    CheckBox1: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox2: TCheckBox;
    Edit1: TEdit;
    Label1: TLabel;
    Label3: TLabel;
    procedure FormShow(Sender: TObject);
    procedure OkButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure Label3Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    procedure LoadProgParam;
    procedure SaveProgParam;
    procedure RestartWindows;
    function ExecuteFile(const FileName, Params, DefaultDir: string;
                         ShowCmd: Integer): THandle;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

 function  RestartDialog; external 'shell32.dll' index 59;

implementation

{$R *.DFM}

function RestartOptionEnumToConst(RestartOption: TkbRestartOption): UINT;
begin
  case (RestartOption) of
    kbsdLogoff:         Result := EWX_LOGOFF;
    kbsdShutdown:       Result := EWX_SHUTDOWN;
    kbsdReboot:         Result := EWX_REBOOT;
    kbsdRestartWindows: Result := EW_RESTARTWINDOWS;
    kbsdRebootSystem:   Result := EW_REBOOTSYSTEM;
    kbsdExitAndExecApp: Result := EW_EXITANDEXECAPP;
    else                Result := 0;
  end;
end;

procedure TForm1.LoadProgParam;
var
 FIniFile: TRegIniFile;
begin
 FIniFile := TRegIniFile.Create('Software');
 FIniFile.OpenKey('VR',true);
 FIniFile.OpenKey('VR-Online',true);
 Width:=FIniFile.ReadInteger('Option', 'Width', 600);
 Height:=FIniFile.ReadInteger('Option', 'Heigth', 400);
 Left:=FIniFile.ReadInteger('Option', 'Left', 10);
 Top:=FIniFile.ReadInteger('Option', 'Top', 10);
 WindowState:=TWindowState(FIniFile.ReadInteger('Option', 'WinState', 2));
 FIniFile.Free;
end;

procedure TForm1.FormShow(Sender: TObject);
var
 FIniFile: TRegIniFile;
 Buffer:array[0..4] of char;
begin
 LoadProgParam;
 FIniFile := TRegIniFile.Create('Software');
 FIniFile.OpenKey('Microsoft',true);
 FIniFile.OpenKey('Windows',true);
 FIniFile.OpenKey('CurrentVersion',true);
 FIniFile.OpenKey('Policies',true);
 FIniFile.OpenKey('Explorer',true);

 buffer[0]:=#0;
 FIniFile.ReadBinaryData('NoClose', Buffer, 4);
 if buffer[0]=#1 then CheckBox1.Checked:=true;

 buffer[0]:=#0;
 FIniFile.ReadBinaryData('NoFavoritesMenu', Buffer, 4);
 if buffer[0]=#1 then CheckBox2.Checked:=true;

 buffer[0]:=#0;
 FIniFile.ReadBinaryData('NoFind', Buffer, 4);
 if buffer[0]=#1 then CheckBox3.Checked:=true;

 buffer[0]:=#0;
 FIniFile.ReadBinaryData('NoLogOff', Buffer, 4);
 if buffer[0]=#1 then CheckBox4.Checked:=true;

 buffer[0]:=#0;
 FIniFile.ReadBinaryData('NoRecentDocsMenu', Buffer, 4);
 if buffer[0]=#1 then CheckBox5.Checked:=true;

 buffer[0]:=#0;
 FIniFile.ReadBinaryData('NoRun', Buffer, 4);
 if buffer[0]=#1 then CheckBox6.Checked:=true;

 buffer[0]:=#0;
 FIniFile.ReadBinaryData('NoSetFolders', Buffer, 4);
 if buffer[0]=#1 then CheckBox7.Checked:=true;

 FIniFile.CloseKey;
 FIniFile.OpenKey('Control Panel',true);
 Edit1.Text:=FIniFile.ReadString('Desktop', 'MenuShowDelay', '');

 FIniFile.Free;
end;

procedure TForm1.OkButtonClick(Sender: TObject);
var
 FIniFile: TRegIniFile;
 Buffer:array[0..4] of char;
begin
 FIniFile := TRegIniFile.Create('Software');
 FIniFile.OpenKey('Microsoft',true);
 FIniFile.OpenKey('Windows',true);
 FIniFile.OpenKey('CurrentVersion',true);
 FIniFile.OpenKey('Policies',true);
 FIniFile.OpenKey('Explorer',true);

 buffer[0]:=#0;
 buffer[1]:=#0;
 buffer[2]:=#0;
 buffer[3]:=#0;
 if CheckBox1.Checked=true then buffer[0]:=#1
 else buffer[0]:=#0;
 FIniFile.WriteBinaryData('NoClose', Buffer, 4);

 if CheckBox2.Checked=true then buffer[0]:=#1
 else buffer[0]:=#0;
 FIniFile.WriteBinaryData('NoFavoritesMenu', Buffer, 4);

 if CheckBox3.Checked=true then buffer[0]:=#1
 else buffer[0]:=#0;
 FIniFile.WriteBinaryData('NoFind', Buffer, 4);

 if CheckBox4.Checked=true then buffer[0]:=#1
 else buffer[0]:=#0;
 FIniFile.WriteBinaryData('NoLogOff', Buffer, 4);

 if CheckBox5.Checked=true then buffer[0]:=#1
 else buffer[0]:=#0;
 FIniFile.WriteBinaryData('NoRecentDocsMenu', Buffer, 4);

 if CheckBox6.Checked=true then buffer[0]:=#1
 else buffer[0]:=#0;
 FIniFile.WriteBinaryData('NoRun', Buffer, 4);

 if CheckBox7.Checked=true then buffer[0]:=#1
 else buffer[0]:=#0;
 FIniFile.WriteBinaryData('NoSetFolders', Buffer, 4);

 FIniFile.CloseKey;
 FIniFile.OpenKey('Control Panel',true);
 if Edit1.Text<>'' then
  FIniFile.WriteString('Desktop', 'MenuShowDelay', Edit1.Text);

 FIniFile.Free;

 RestartWindows;
 Close;
end;

procedure TForm1.CancelButtonClick(Sender: TObject);
begin
 Close;
end;

procedure TForm1.RestartWindows;
const
  Space = ' ';
var
  ReasonString: AnsiString;
  ReasonBuffer: Pointer;
begin
  ReasonString := EmptyStr + Space;
  GetMem(ReasonBuffer, (Length(ReasonString) + 1) * SizeOf(WideChar));
  try
   if (SysUtils.Win32Platform = VER_PLATFORM_WIN32_NT) then 
    StringToWideChar(ReasonString, PWideChar(ReasonBuffer), (Length(ReasonString) + 1))
   else 
    StrPCopy(PChar(ReasonBuffer), ReasonString);

   RestartDialog(Application.Handle, PWideChar(ReasonBuffer), RestartOptionEnumToConst(kbsdRestartWindows));
  finally
    FreeMem(ReasonBuffer);
  end; 
end;

function TForm1.ExecuteFile(const FileName, Params, DefaultDir: string;
  ShowCmd: Integer): THandle;
var
  zFileName, zParams, zDir: array[0..79] of Char;
begin
  Result := ShellExecute(Application.MainForm.Handle, nil,
    StrPCopy(zFileName, FileName), StrPCopy(zParams, Params),
    StrPCopy(zDir, DefaultDir), ShowCmd);
end;

procedure TForm1.SaveProgParam;
var
 FIniFile: TRegIniFile;
begin
 FIniFile := TRegIniFile.Create('Software');
 FIniFile.OpenKey('VR',true);
 FIniFile.OpenKey('VR-Online',true);
 if WindowState=wsNormal then
  begin
   FIniFile.WriteInteger('Option', 'Width', Width);
   FIniFile.WriteInteger('Option', 'Heigth', Height);
   FIniFile.WriteInteger('Option', 'Left', Left);
   FIniFile.WriteInteger('Option', 'Top', Top);
  end;
 FIniFile.WriteInteger('Option', 'WinState', Integer(WindowState));
 FIniFile.Free;
end;

procedure TForm1.Label3Click(Sender: TObject);
begin
 ExecuteFile('http://www.x-c-r.com/','','',SW_SHOW);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 SaveProgParam;
end;

end.
